<?php

/**
 * no_planilla_nom actions.
 *
 * @package    nomina
 * @subpackage no_planilla_nom
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class no_planilla_nomActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tipcod, codigo';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            /**
             * filtro func con retefuente - 20140710
             */
            $tag_rete = $request['tag_rete'];

            /*
             * Variables opcionales
             */
            //clase planta
            if (isset($request['id_clase_planta'])) {
                $whereClasePlanta = " AND tab0.id_clase_planta = " . $request['id_clase_planta'];
            } else {
                $whereClasePlanta = ' ';
            }

            //pago - true por 1 y false por 0
            if (isset($request['pago'])) {
                if ($request['pago'] == 'true') {
                    //Si es true
                    $pago = 1;
                    $wherePago = " AND tab0.pago = 1 ";
                } elseif ($request['pago'] == '0') {
                    //Si es 0
                    $pago = 0;
                    $wherePago = " AND tab0.pago = 0 ";
                } else {
                    //Si es false
                    $pago = 0;
                    $wherePago = " ";
                }
            }
            
            //centro operacion - 20160426
            if (isset($request['id_cen_op'])) {
                $whereCenOp = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOp = ' ';
            }
            
            //planta - 20200120
            if (isset($request['id_planta'])) {
                $wherePlanta = " AND tab0.id_planta = " . $request['id_planta'];
            } else {
                $wherePlanta = ' ';
            }
            
            

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 

informe.id_periodo,
informe.tipcod,
informe.tipo,
informe.tipcod || ' - ' || informe.tipo as completo_tipo,
informe.codigo,
informe.descripcion,
informe.valor,
funcionarios.cantidad as cantidad,
(
select distinct periodo.periodo 
from no_periodo_v periodo 
where periodo.id_periodo = $periodo_filtro
) as periodo

from(

        select id_periodo,tipcod,tipo,codigo,descripcion, sum(valor_liquidado) valor
        from(
    
            select tab0.* from(

                select 
                liquida.id_periodo,tipo.codigo as tipcod,tipo.descripcion as tipo,
                concep.codigo,concep.descripcion,liquida.valor_liquidado,liquida.num_doc,
                tab6.id_planta_p as id_planta,    
                tab5.id_cen_op
                from no_liquida_nomina liquida
                left join no_concep_nomina concep on concep.id_concep_nomina = liquida.id_concep_nomina and concep.pago_func = 1
                left join no_tipo_concepto tipo on tipo.id_tipo_concepto = concep.id_tipo_concepto
                    left join (

                          select nom.*,
                          case when tab.num_doc is not null then 1 else 0 end as pago
                          from no_nombramiento_v nom

                          left join (select distinct
                          pago.id_tipo_doc,
                          pago.num_doc 
                          from no_pago_func pago
                          where
                          (select fecha_fin from no_periodo where id_periodo = $periodo_filtro) between pago.fecha_activacion and nvl(pago.fecha_terminacion, (select fecha_fin from no_periodo where id_periodo = $periodo_filtro))
                          )tab 
                          on tab.id_tipo_doc = nom.id_tipo_doc and tab.num_doc = nom.num_doc

                    )tab0
                    on tab0.id_tipo_doc = liquida.id_tipo_doc and tab0.num_doc = liquida.num_doc
                
                
                left join NO_ESTADO_FUNC_V tab5 on
                tab5.id_tipo_doc = liquida.id_tipo_doc
                and tab5.num_doc = liquida.num_doc
                and tab5.periodo = liquida.id_periodo
                
                left join NO_DP_V tab6 on
                    tab6.id_dp=tab5.id_dp
                where liquida.id_periodo = $periodo_filtro 
                and tipo.id_tipo_concepto!=4 $whereClasePlanta $wherePago  
                                       
                --filtro func con retefuente - 20140710
                and (
                0 = $tag_rete
                or
                liquida.num_doc in (select distinct tab.num_doc from no_liquida_nomina tab where tab.id_periodo = $periodo_filtro and tab.id_concep_nomina = (select no_param_concep.id_concep_rete from no_param_concep))
                ) 
        
            )tab0

            where        
            1 = 1
            $whereCenOp
                    $wherePlanta 

        )group by id_periodo,tipcod,tipo,codigo,descripcion

)informe

left join(

    select concep.codigo,count(concep.num_doc) cantidad    
    from (
    
        select tab0.* from(
    
            select 
            concep.codigo,
            liquida.num_doc,
            tab6.id_planta_p as id_planta,    
            tab5.id_cen_op
                    
            from no_liquida_nomina liquida
            left join no_concep_nomina concep on concep.id_concep_nomina = liquida.id_concep_nomina and concep.pago_func = 1
            left join no_tipo_concepto tipo on tipo.id_tipo_concepto = concep.id_tipo_concepto
            left join (

                  select nom.*,
                  case when tab.num_doc is not null then 1 else 0 end as pago
                  from no_nombramiento_v nom

                  left join (select distinct
                  pago.id_tipo_doc,
                  pago.num_doc 
                  from no_pago_func pago
                  where
                  (select fecha_fin from no_periodo where id_periodo = $periodo_filtro) between pago.fecha_activacion and nvl(pago.fecha_terminacion, (select fecha_fin from no_periodo where id_periodo = $periodo_filtro))
                  )tab 
                  on tab.id_tipo_doc = nom.id_tipo_doc and tab.num_doc = nom.num_doc

            )tab0
            on tab0.id_tipo_doc = liquida.id_tipo_doc and tab0.num_doc = liquida.num_doc

            left join NO_ESTADO_FUNC_V tab5 on
            tab5.id_tipo_doc = liquida.id_tipo_doc
            and tab5.num_doc = liquida.num_doc
            and tab5.periodo = liquida.id_periodo                
                    
             left join NO_DP_V tab6 on
                    tab6.id_dp=tab5.id_dp
            where liquida.id_periodo = $periodo_filtro 
            and tipo.id_tipo_concepto != 4 $whereClasePlanta $wherePago  
                    
            --filtro func con retefuente - 20140710
            and (
            0 = $tag_rete
            or
            liquida.num_doc in (select distinct tab.num_doc from no_liquida_nomina tab where tab.id_periodo = $periodo_filtro and tab.id_concep_nomina = (select no_param_concep.id_concep_rete from no_param_concep))
            ) 
        
        )tab0

        where        
        1 = 1
        $whereCenOp
        $wherePlanta 
    )concep
    
    group by concep.codigo

)funcionarios on funcionarios.codigo = informe.codigo

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 

informe.id_periodo,
informe.tipcod,
informe.tipo,
informe.tipcod || ' - ' || informe.tipo as completo_tipo,
informe.codigo,
informe.descripcion,
informe.valor,
funcionarios.cantidad as cantidad,
(
select distinct periodo.periodo 
from no_periodo_v periodo 
where periodo.id_periodo = $periodo_filtro
) as periodo

from(

        select id_periodo,tipcod,tipo,codigo,descripcion, sum(valor_liquidado) valor
        from(
    
            select tab0.* from(

                select 
                liquida.id_periodo,tipo.codigo as tipcod,tipo.descripcion as tipo,
                concep.codigo,concep.descripcion,liquida.valor_liquidado,liquida.num_doc,
                tab6.id_planta_p as id_planta,    
                tab5.id_cen_op    
                from no_liquida_nomina liquida
                left join no_concep_nomina concep on concep.id_concep_nomina = liquida.id_concep_nomina and concep.pago_func = 1
                left join no_tipo_concepto tipo on tipo.id_tipo_concepto = concep.id_tipo_concepto
                    left join (

                          select nom.*,
                          case when tab.num_doc is not null then 1 else 0 end as pago
                          from no_nombramiento_v nom

                          left join (select distinct
                          pago.id_tipo_doc,
                          pago.num_doc 
                          from no_pago_func pago
                          where
                          (select fecha_fin from no_periodo where id_periodo = $periodo_filtro) between pago.fecha_activacion and nvl(pago.fecha_terminacion, (select fecha_fin from no_periodo where id_periodo = $periodo_filtro))
                          )tab 
                          on tab.id_tipo_doc = nom.id_tipo_doc and tab.num_doc = nom.num_doc

                    )tab0
                    on tab0.id_tipo_doc = liquida.id_tipo_doc and tab0.num_doc = liquida.num_doc
                
                
                left join NO_ESTADO_FUNC_V tab5 on
                tab5.id_tipo_doc = liquida.id_tipo_doc
                and tab5.num_doc = liquida.num_doc
                and tab5.periodo = liquida.id_periodo
                    
                left join NO_DP_V tab6 on
                tab6.id_dp=tab5.id_dp
                where liquida.id_periodo = $periodo_filtro 
                and tipo.id_tipo_concepto!=4 $whereClasePlanta $wherePago 
            
                --filtro func con retefuente - 20140710
                and (
                0 = $tag_rete
                or
                liquida.num_doc in (select distinct tab.num_doc from no_liquida_nomina tab where tab.id_periodo = $periodo_filtro and tab.id_concep_nomina = (select no_param_concep.id_concep_rete from no_param_concep))
                ) 
        
            )tab0

            where        
            1 = 1
            $whereCenOp
                     $wherePlanta
        )group by id_periodo,tipcod,tipo,codigo,descripcion

)informe

left join(

    select concep.codigo,count(concep.num_doc) cantidad
    from (
    
        select tab0.* from(
    
            select 
            concep.codigo,
            liquida.num_doc,
            tab6.id_planta_p as id_planta,    
            tab5.id_cen_op
                    
            from no_liquida_nomina liquida
            left join no_concep_nomina concep on concep.id_concep_nomina = liquida.id_concep_nomina and concep.pago_func = 1
            left join no_tipo_concepto tipo on tipo.id_tipo_concepto = concep.id_tipo_concepto
            left join (

                  select nom.*,
                  case when tab.num_doc is not null then 1 else 0 end as pago
                  from no_nombramiento_v nom

                  left join (select distinct
                  pago.id_tipo_doc,
                  pago.num_doc 
                  from no_pago_func pago
                  where
                  (select fecha_fin from no_periodo where id_periodo = $periodo_filtro) between pago.fecha_activacion and nvl(pago.fecha_terminacion, (select fecha_fin from no_periodo where id_periodo = $periodo_filtro))
                  )tab 
                  on tab.id_tipo_doc = nom.id_tipo_doc and tab.num_doc = nom.num_doc

            )tab0
            on tab0.id_tipo_doc = liquida.id_tipo_doc and tab0.num_doc = liquida.num_doc

            left join NO_ESTADO_FUNC_V tab5 on
            tab5.id_tipo_doc = liquida.id_tipo_doc
            and tab5.num_doc = liquida.num_doc
            and tab5.periodo = liquida.id_periodo   
            
            left join NO_DP_V tab6 on
                tab6.id_dp=tab5.id_dp
            where liquida.id_periodo = $periodo_filtro 
            and tipo.id_tipo_concepto != 4 $whereClasePlanta $wherePago  
             
            --filtro func con retefuente - 20140710
            and (
            0 = $tag_rete
            or
            liquida.num_doc in (select distinct tab.num_doc from no_liquida_nomina tab where tab.id_periodo = $periodo_filtro and tab.id_concep_nomina = (select no_param_concep.id_concep_rete from no_param_concep))
            ) 
        
        )tab0

        where        
        1 = 1
        $whereCenOp
                    $wherePlanta
    )concep
    
    group by concep.codigo

)funcionarios on funcionarios.codigo = informe.codigo
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[no_planilla_nom] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
